#!/bin/bash
#
#   uninstaller.sh
#
#   Userful Multiplier installer
#
#  	Copyright (c) 2005-2010 Userful Corporation.  All rights reserved.
#
# 	Jason Kim  <jason@userful.com>

DPKG=$(which dpkg 2>/dev/null | sed 's|^[^/]*||' 2>/dev/null);
RPM=$(which rpm 2>/dev/null | sed 's|^[^/]*||' 2>/dev/null);
#DIALOG=$(which dialog 2>/dev/null | sed 's|^[^/]*||' 2>/dev/null);
DIALOG=""

## List of packages to uninstall
PKG_LIST="multiuser-device-assignment multiuser-audio-fc4 multiuser-removable-storage multistation-devices-storage multistation-devices-multimedia listpci 1box-server-xorg mx11r7 umx-server umx-multimedia umx-storage umx-mesa umx-tusb umx-utils desktop-multiplier"
PKG_CNT=13
PKG_PROGRESS=$((100/$PKG_CNT))
PROGRESS=0

##
## Find Linux TYPE
##
function check_os_info()
{
    if [ -e /etc/fedora-release ] || [ -e /etc/mandrake-release ] || \
       [ -e /etc/SuSE-release ] || [ -e /etc/redhat-release ]; then
       OSTYPE="rpm"

    elif [ -e /etc/xandros-deskktop-version ] || [ -e /etc/morphix_version ] || \
         [ -e /etc/freespire-release ] || [ -e /etc/linspire-release ] || \
         [ -e /etc/debian_version ]; then
       OSTYPE="deb"

   elif [ -e /etc/lsb-release ]; then
       source /etc/lsb-release
       OSTYPE=$(echo $DISTRIB_ID | tr "[A-Z" "[a-z]")

       # Check Linux Educacional
       if [ "$OSTYPE" == "linux educacional" ]; then
           OSTYPE=ubuntu
       fi

   else
       # Unsupported OS type
       # Should exit
       OSTYPE=unsupported

   fi
}

##
## Exit from installer.sh
##
function exit_uninstaller()
{
    #read -s -p "Please enter any key to exit from \`uninstaller.sh'"
    echo ""
    exit 1
}

##
## uninstall UMx 
##
function uninstall_umx()
{
    if [[ -n "$DIALOG" ]]; then
        
        { for PKG in $PKG_LIST; do

            if [ "$OSTYPE" == "rpm" ]; then
                $RPM -q --quiet $PKG
                if [[ $? -eq 0 ]]; then
                    $RPM -e $PKG > /dev/null 2>&1
                fi
            elif [ "$OSTYPE" == "deb" ] || [ "$OSTYPE" == "ubuntu" ]; then
                $DPKG -r $PKG > /dev/null 2>&1
            fi

            PROGRESS=$(($PROGRESS+$PKG_PROGRESS))
            echo $PROGRESS
        done
        echo 100; } | $DIALOG  --backtitle "$BACKTITLE" --guage "Uninstalling Userful Multiplier... " 6 70 0

    else
        echo -e "Uninstalling packages...."
        for PKG in $PKG_LIST; do

            if [ "$OSTYPE" == "rpm" ]; then
                $RPM -q --quiet $PKG
                if [[ $? -eq 0 ]]; then
                    $RPM -e $PKG > /dev/null 2>&1
                fi

            elif [ "$OSTYPE" == "deb" ] || [ "$OSTYPE" == "ubuntu" ]; then
                $DPKG -r $PKG > /dev/null 2>&1
            fi
            PROGRESS=$(($PROGRESS+$PKG_PROGRESS))
            echo -n "$PROGRESS%  "
        done
        echo -n "100%"
    fi

    echo; echo
    #read -s -p "Done... Please enter any key to exit from \`uninstaller.sh"

}

#-------------------
# Script start here
#-------------------

##
## Check root
if [ ! -r /proc/kmsg ]; then
    echo 
    echo "You must be root to uninstall Userful Multiplier"
    echo
    echo "To change root user in a terminal, type \`su -' command."
    echo "If you uninstall Userful Multiplier in graphical mode, please log on as root."
    echo
    #exit_uninstaller
fi

if [ ! -e /opt/userful/bin/MXsetup ]; then
    echo
    echo "Userful Multiplier is not installed on your system."
    echo
    exit_uninstaller
fi
    
##
## Find Linux type.
if [ -e ./new-distro.conf ]; then
    source ./new-distro.conf

    if [ x"$PACKAGE_TYPE" != x ]; then
        OSTYPE=$PACKAGE_TYPE
    fi
else
    check_os_info
fi

echo

## Uninstall packages based on the OS Type
if [ "$OSTYPE" == "rpm" ] || [ "$OSTYPE" == "deb" ] || [ "$OSTYPE" == "ubuntu" ]; then

    uninstall_umx
    echo ""
else
    # Shouldn't reach here
    # Unsupported OS type
    echo "Unsupported Linux system."
    echo "UMx uninstaller.sh"
    exit_uninstaller
fi

